using System;

namespace IceNullRefExceptionInParamPatcher
{
	class SimpleImpl : Demo._SimpleOperations
	{
		#region _SimpleOperations Member

		public void ProcA(Demo.A obj, Ice.Current __current)
		{
			Console.WriteLine( "Processing A: {0}", obj.f() );
		}

		#endregion
	}
	class Class1
	{
		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			try
			{
				Ice.Communicator comm = Ice.Util.initialize( ref args );

				comm.addObjectFactory( new AObjectFactory(), "::Demo::A" );

				Ice.ObjectAdapter adapter = comm.createObjectAdapterWithEndpoints( "DemoAdapter", "tcp" );

				Ice.ObjectPrx p = adapter.addWithUUID( new Demo._SimpleTie( new SimpleImpl() ) );
				p = p.ice_collocationOptimization( false );

				adapter.activate();

				Demo.SimplePrx sp = Demo.SimplePrxHelper.uncheckedCast( p );

				sp.ProcA( null );

				comm.shutdown();
				comm.destroy();
			}
			catch( Exception ex )
			{
				Console.WriteLine( ex.ToString() );
			}
		}
	}
}
