// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 2.1.2
// Generated from file `Simple.ice'

using _System = System;
using _Microsoft = Microsoft;

namespace Demo
{
    public abstract class A : Ice.ObjectImpl, _AOperations, _AOperationsNC
    {
	#region Slice operations

	public int f()
	{
	    return f(Ice.ObjectImpl.defaultCurrent);
	}
	public abstract int f(Ice.Current __current);

	#endregion // Slice operations

	#region Slice type-related members

	public static new string[] __ids = 
	{
	    "::Demo::A",
	    "::Ice::Object"
	};

	public override bool ice_isA(string s)
	{
	    if(IceInternal.AssemblyUtil._runtime == IceInternal.AssemblyUtil.Runtime.Mono)
	    {
		// Mono bug: System.Array.BinarySearch() uses the wrong collation sequence,
		// so we do a linear search for the time being
		int pos = 0;
		while(pos < __ids.Length)
		{
		    if(__ids[pos] == s)
		    {
			break;
		    }
		    ++pos;
		}
		if(pos == __ids.Length)
		{
		    pos = -1;
		}
		return pos >= 0;
	    }
	    else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override bool ice_isA(string s, Ice.Current __current)
	{
	    if(IceInternal.AssemblyUtil._runtime == IceInternal.AssemblyUtil.Runtime.Mono)
	    {
		// Mono bug: System.Array.BinarySearch() uses the wrong collation sequence,
		// so we do a linear search for the time being
		int pos = 0;
		while(pos < __ids.Length)
		{
		    if(__ids[pos] == s)
		    {
			break;
		    }
		    ++pos;
		}
		if(pos == __ids.Length)
		{
		    pos = -1;
		}
		return pos >= 0;
	    }
	    else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override string[] ice_ids()
	{
	    return __ids;
	}

	public override string[] ice_ids(Ice.Current __current)
	{
	    return __ids;
	}

	public override string ice_id()
	{
	    return __ids[0];
	}

	public override string ice_id(Ice.Current __current)
	{
	    return __ids[0];
	}

	public static new string ice_staticId()
	{
	    return __ids[0];
	}

	#endregion

	#region Operation dispatch

	public static IceInternal.DispatchStatus ___f(A __obj, IceInternal.Incoming __inS, Ice.Current __current)
	{
	    IceInternal.BasicStream __os = __inS.ostr();
	    int __ret = __obj.f(__current);
	    __os.writeInt(__ret);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	private static string[] __all =
	{
	    "f",
	    "ice_id",
	    "ice_ids",
	    "ice_isA",
	    "ice_ping"
	};

	public override IceInternal.DispatchStatus __dispatch(IceInternal.Incoming __inS, Ice.Current __current)
	{
	    int pos;
	    if(IceInternal.AssemblyUtil._runtime == IceInternal.AssemblyUtil.Runtime.Mono)
	    {
		// Mono bug: System.Array.BinarySearch() uses the wrong collation sequence,
		// so we do a linear search for the time being
		pos = 0;
		while(pos < __all.Length)
		{
		    if(__all[pos] == __current.operation)
		    {
			break;
		    }
		    ++pos;
		}
		if(pos == __all.Length)
		{
		    pos = -1;
		}
	    }
	    else
	    {
		pos = _System.Array.BinarySearch(__all, __current.operation, _System.Collections.Comparer.DefaultInvariant);
	    }
	    if(pos < 0)
	    {
		return IceInternal.DispatchStatus.DispatchOperationNotExist;
	    }

	    switch(pos)
	    {
		case 0:
		{
		    return ___f(this, __inS, __current);
		}
		case 1:
		{
		    return ___ice_id(this, __inS, __current);
		}
		case 2:
		{
		    return ___ice_ids(this, __inS, __current);
		}
		case 3:
		{
		    return ___ice_isA(this, __inS, __current);
		}
		case 4:
		{
		    return ___ice_ping(this, __inS, __current);
		}
	    }

	    _System.Diagnostics.Debug.Assert(false);
	    return IceInternal.DispatchStatus.DispatchOperationNotExist;
	}

	#endregion

	#region Marshaling support

	public override void __write(IceInternal.BasicStream __os)
	{
	    __os.writeTypeId(ice_staticId());
	    __os.startWriteSlice();
	    __os.endWriteSlice();
	    base.__write(__os);
	}

	public override void __read(IceInternal.BasicStream __is, bool __rid)
	{
	    if(__rid)
	    {
		/* string myId = */ __is.readTypeId();
	    }
	    __is.startReadSlice();
	    __is.endReadSlice();
	    base.__read(__is, true);
	}

	public override void __write(Ice.OutputStream __outS)
	{
	    Ice.MarshalException ex = new Ice.MarshalException();
	    ex.reason = "type Demo::A was not generated with stream support";
	    throw ex;
	}

	public override void __read(Ice.InputStream __inS, bool __rid)
	{
	    Ice.MarshalException ex = new Ice.MarshalException();
	    ex.reason = "type Demo::A was not generated with stream support";
	    throw ex;
	}

	#endregion
    }

    public interface Simple : Ice.Object, _SimpleOperations, _SimpleOperationsNC
    {
    }
}

namespace Demo
{
    public interface APrx : Ice.ObjectPrx
    {
	int f();
	int f(Ice.Context __context);
    }

    public interface SimplePrx : Ice.ObjectPrx
    {
	void ProcA(Demo.A obj);
	void ProcA(Demo.A obj, Ice.Context __context);
    }
}

namespace Demo
{
    public interface _AOperations
    {
	int f(Ice.Current __current);
    }

    public interface _AOperationsNC
    {
	int f();
    }

    public interface _SimpleOperations
    {
	void ProcA(Demo.A obj, Ice.Current __current);
    }

    public interface _SimpleOperationsNC
    {
	void ProcA(Demo.A obj);
    }
}

namespace Demo
{
    public sealed class APrxHelper : Ice.ObjectPrxHelperBase, APrx
    {
	#region Synchronous operations

	public int f()
	{
	    return f(__defaultContext());
	}

	public int f(Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    __checkTwowayOnly("f");
		    Ice._ObjectDel __delBase = __getDelegate();
		    _ADel __del = (_ADel)__delBase;
		    return __del.f(__context);
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	#endregion

	#region Checked and unchecked cast operations

	public static APrx checkedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is APrx)
	    {
		return (APrx)b;
	    }
	    if(b.ice_isA("::Demo::A"))
	    {
		APrxHelper h = new APrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static APrx checkedCast(Ice.ObjectPrx b, Ice.Context ctx)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is APrx)
	    {
		return (APrx)b;
	    }
	    if(b.ice_isA("::Demo::A", ctx))
	    {
		APrxHelper h = new APrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static APrx checkedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::Demo::A"))
		{
		    APrxHelper h = new APrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static APrx checkedCast(Ice.ObjectPrx b, string f, Ice.Context ctx)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::Demo::A", ctx))
		{
		    APrxHelper h = new APrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static APrx uncheckedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    APrxHelper h = new APrxHelper();
	    h.__copyFrom(b);
	    return h;
	}

	public static APrx uncheckedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    APrxHelper h = new APrxHelper();
	    h.__copyFrom(bb);
	    return h;
	}

	#endregion

	#region Marshaling support

	protected override Ice._ObjectDelM __createDelegateM()
	{
	    return new _ADelM();
	}

	protected override Ice._ObjectDelD __createDelegateD()
	{
	    return new _ADelD();
	}

	public static void __write(IceInternal.BasicStream __os, APrx __v)
	{
	    __os.writeProxy(__v);
	}

	public static APrx __read(IceInternal.BasicStream __is)
	{
	    Ice.ObjectPrx proxy = __is.readProxy();
	    if(proxy != null)
	    {
		APrxHelper result = new APrxHelper();
		result.__copyFrom(proxy);
		return result;
	    }
	    return null;
	}

	#endregion
    }

    public sealed class SimplePrxHelper : Ice.ObjectPrxHelperBase, SimplePrx
    {
	#region Synchronous operations

	public void ProcA(Demo.A obj)
	{
	    ProcA(obj, __defaultContext());
	}

	public void ProcA(Demo.A obj, Ice.Context __context)
	{
	    int __cnt = 0;
	    while(true)
	    {
		try
		{
		    Ice._ObjectDel __delBase = __getDelegate();
		    _SimpleDel __del = (_SimpleDel)__delBase;
		    __del.ProcA(obj, __context);
		    return;
		}
		catch(IceInternal.NonRepeatable __ex)
		{
		    __rethrowException(__ex.get());
		}
		catch(Ice.LocalException __ex)
		{
		    __cnt = __handleException(__ex, __cnt);
		}
	    }
	}

	#endregion

	#region Checked and unchecked cast operations

	public static SimplePrx checkedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is SimplePrx)
	    {
		return (SimplePrx)b;
	    }
	    if(b.ice_isA("::Demo::Simple"))
	    {
		SimplePrxHelper h = new SimplePrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static SimplePrx checkedCast(Ice.ObjectPrx b, Ice.Context ctx)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is SimplePrx)
	    {
		return (SimplePrx)b;
	    }
	    if(b.ice_isA("::Demo::Simple", ctx))
	    {
		SimplePrxHelper h = new SimplePrxHelper();
		h.__copyFrom(b);
		return h;
	    }
	    return null;
	}

	public static SimplePrx checkedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::Demo::Simple"))
		{
		    SimplePrxHelper h = new SimplePrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static SimplePrx checkedCast(Ice.ObjectPrx b, string f, Ice.Context ctx)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::Demo::Simple", ctx))
		{
		    SimplePrxHelper h = new SimplePrxHelper();
		    h.__copyFrom(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static SimplePrx uncheckedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    SimplePrxHelper h = new SimplePrxHelper();
	    h.__copyFrom(b);
	    return h;
	}

	public static SimplePrx uncheckedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    SimplePrxHelper h = new SimplePrxHelper();
	    h.__copyFrom(bb);
	    return h;
	}

	#endregion

	#region Marshaling support

	protected override Ice._ObjectDelM __createDelegateM()
	{
	    return new _SimpleDelM();
	}

	protected override Ice._ObjectDelD __createDelegateD()
	{
	    return new _SimpleDelD();
	}

	public static void __write(IceInternal.BasicStream __os, SimplePrx __v)
	{
	    __os.writeProxy(__v);
	}

	public static SimplePrx __read(IceInternal.BasicStream __is)
	{
	    Ice.ObjectPrx proxy = __is.readProxy();
	    if(proxy != null)
	    {
		SimplePrxHelper result = new SimplePrxHelper();
		result.__copyFrom(proxy);
		return result;
	    }
	    return null;
	}

	#endregion
    }
}

namespace Demo
{
    public interface _ADel : Ice._ObjectDel
    {
	int f(Ice.Context __context);
    }

    public interface _SimpleDel : Ice._ObjectDel
    {
	void ProcA(Demo.A obj, Ice.Context __context);
    }
}

namespace Demo
{
    public sealed class _ADelM : Ice._ObjectDelM, _ADel
    {
	public int f(Ice.Context __context)
	{
	    IceInternal.Outgoing __outS = getOutgoing("f", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		IceInternal.BasicStream __is = __outS.istr();
		if(!__outS.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
		try
		{
		    int __ret;
		    __ret = __is.readInt();
		    return __ret;
		}
		catch(Ice.LocalException __ex)
		{
		    throw new IceInternal.NonRepeatable(__ex);
		}
	    }
	    finally
	    {
		reclaimOutgoing(__outS);
	    }
	}
    }

    public sealed class _SimpleDelM : Ice._ObjectDelM, _SimpleDel
    {
	public void ProcA(Demo.A obj, Ice.Context __context)
	{
	    IceInternal.Outgoing __outS = getOutgoing("ProcA", Ice.OperationMode.Normal, __context, __compress);
	    try
	    {
		try
		{
		    IceInternal.BasicStream __os = __outS.ostr();
		    __os.writeObject(obj);
		    __os.writePendingObjects();
		}
		catch(Ice.LocalException __ex)
		{
		    __outS.abort(__ex);
		}
		if(!__outS.invoke())
		{
		    throw new Ice.UnknownUserException();
		}
	    }
	    finally
	    {
		reclaimOutgoing(__outS);
	    }
	}
    }
}

namespace Demo
{
    public sealed class _ADelD : Ice._ObjectDelD, _ADel
    {
	public int f(Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "f", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is A)
		{
		    try
		    {
			return ((Demo.A)__servant).f(__current);
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}
    }

    public sealed class _SimpleDelD : Ice._ObjectDelD, _SimpleDel
    {
	public void ProcA(Demo.A obj, Ice.Context __context)
	{
	    Ice.Current __current = new Ice.Current();
	    __initCurrent(ref __current, "ProcA", Ice.OperationMode.Normal, __context);
	    while(true)
	    {
		IceInternal.Direct __direct = new IceInternal.Direct(__current);
		object __servant = __direct.servant();
		if(__servant is Simple)
		{
		    try
		    {
			((Demo.Simple)__servant).ProcA(obj, __current);
			return;
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.NonRepeatable(__ex);
		    }
		    finally
		    {
			__direct.destroy();
		    }
		}
		else
		{
		    __direct.destroy();
		    Ice.OperationNotExistException __opEx = new Ice.OperationNotExistException();
		    __opEx.id = __current.id;
		    __opEx.facet = __current.facet;
		    __opEx.operation = __current.operation;
		    throw __opEx;
		}
	    }
	}
    }
}

namespace Demo
{
    public abstract class _SimpleDisp : Ice.ObjectImpl, Simple
    {
	#region Slice operations

	public void ProcA(Demo.A obj)
	{
	    ProcA(obj, Ice.ObjectImpl.defaultCurrent);
	}

	public abstract void ProcA(Demo.A obj, Ice.Current __current);

	#endregion

	#region Slice type-related members

	public static new string[] __ids = 
	{
	    "::Demo::Simple",
	    "::Ice::Object"
	};

	public override bool ice_isA(string s)
	{
	    if(IceInternal.AssemblyUtil._runtime == IceInternal.AssemblyUtil.Runtime.Mono)
	    {
		// Mono bug: System.Array.BinarySearch() uses the wrong collation sequence,
		// so we do a linear search for the time being
		int pos = 0;
		while(pos < __ids.Length)
		{
		    if(__ids[pos] == s)
		    {
			break;
		    }
		    ++pos;
		}
		if(pos == __ids.Length)
		{
		    pos = -1;
		}
		return pos >= 0;
	    }
	    else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override bool ice_isA(string s, Ice.Current __current)
	{
	    if(IceInternal.AssemblyUtil._runtime == IceInternal.AssemblyUtil.Runtime.Mono)
	    {
		// Mono bug: System.Array.BinarySearch() uses the wrong collation sequence,
		// so we do a linear search for the time being
		int pos = 0;
		while(pos < __ids.Length)
		{
		    if(__ids[pos] == s)
		    {
			break;
		    }
		    ++pos;
		}
		if(pos == __ids.Length)
		{
		    pos = -1;
		}
		return pos >= 0;
	    }
	    else
	    {
		return _System.Array.BinarySearch(__ids, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override string[] ice_ids()
	{
	    return __ids;
	}

	public override string[] ice_ids(Ice.Current __current)
	{
	    return __ids;
	}

	public override string ice_id()
	{
	    return __ids[0];
	}

	public override string ice_id(Ice.Current __current)
	{
	    return __ids[0];
	}

	public static new string ice_staticId()
	{
	    return __ids[0];
	}

	#endregion

	#region Operation dispatch

	public static IceInternal.DispatchStatus ___ProcA(Simple __obj, IceInternal.Incoming __inS, Ice.Current __current)
	{
	    IceInternal.BasicStream __is = __inS.istr();
	    IceInternal.ParamPatcher obj_PP = new IceInternal.ParamPatcher(typeof(Demo.A));
	    __is.readObject(obj_PP);
	    __is.readPendingObjects();
	    __obj.ProcA((Demo.A)obj_PP.value, __current);
	    return IceInternal.DispatchStatus.DispatchOK;
	}

	private static string[] __all =
	{
	    "ice_id",
	    "ice_ids",
	    "ice_isA",
	    "ice_ping",
	    "ProcA"
	};

	public override IceInternal.DispatchStatus __dispatch(IceInternal.Incoming __inS, Ice.Current __current)
	{
	    int pos;
	    if(IceInternal.AssemblyUtil._runtime == IceInternal.AssemblyUtil.Runtime.Mono)
	    {
		// Mono bug: System.Array.BinarySearch() uses the wrong collation sequence,
		// so we do a linear search for the time being
		pos = 0;
		while(pos < __all.Length)
		{
		    if(__all[pos] == __current.operation)
		    {
			break;
		    }
		    ++pos;
		}
		if(pos == __all.Length)
		{
		    pos = -1;
		}
	    }
	    else
	    {
		pos = _System.Array.BinarySearch(__all, __current.operation, _System.Collections.Comparer.DefaultInvariant);
	    }
	    if(pos < 0)
	    {
		return IceInternal.DispatchStatus.DispatchOperationNotExist;
	    }

	    switch(pos)
	    {
		case 0:
		{
		    return ___ice_id(this, __inS, __current);
		}
		case 1:
		{
		    return ___ice_ids(this, __inS, __current);
		}
		case 2:
		{
		    return ___ice_isA(this, __inS, __current);
		}
		case 3:
		{
		    return ___ice_ping(this, __inS, __current);
		}
		case 4:
		{
		    return ___ProcA(this, __inS, __current);
		}
	    }

	    _System.Diagnostics.Debug.Assert(false);
	    return IceInternal.DispatchStatus.DispatchOperationNotExist;
	}

	#endregion
    }
}

namespace Demo
{
    public class _ATie : A, Ice.TieBase
    {
	public _ATie()
	{
	}

	public _ATie(_AOperations del)
	{
	    _ice_delegate = del;
	}

	public object ice_delegate()
	{
	    return _ice_delegate;
	}

	public void ice_delegate(object del)
	{
	    _ice_delegate = (_AOperations)del;
	}

	public override int ice_hash()
	{
	    return GetHashCode();
	}

	public override int GetHashCode()
	{
	    return _ice_delegate == null ? 0 : _ice_delegate.GetHashCode();
	}

	public override bool Equals(object rhs)
	{
	    if(object.ReferenceEquals(this, rhs))
	    {
		return true;
	    }
	    if(!(rhs is _ATie))
	    {
		return false;
	    }
	    if(_ice_delegate == null)
	    {
		return ((_ATie)rhs)._ice_delegate == null;
	    }
	    return _ice_delegate.Equals(((_ATie)rhs)._ice_delegate);
	}

	public override int f(Ice.Current __current)
	{
	    return _ice_delegate.f(__current);
	}

	private _AOperations _ice_delegate;
    }

    public class _SimpleTie : _SimpleDisp, Ice.TieBase
    {
	public _SimpleTie()
	{
	}

	public _SimpleTie(_SimpleOperations del)
	{
	    _ice_delegate = del;
	}

	public object ice_delegate()
	{
	    return _ice_delegate;
	}

	public void ice_delegate(object del)
	{
	    _ice_delegate = (_SimpleOperations)del;
	}

	public override int ice_hash()
	{
	    return GetHashCode();
	}

	public override int GetHashCode()
	{
	    return _ice_delegate == null ? 0 : _ice_delegate.GetHashCode();
	}

	public override bool Equals(object rhs)
	{
	    if(object.ReferenceEquals(this, rhs))
	    {
		return true;
	    }
	    if(!(rhs is _SimpleTie))
	    {
		return false;
	    }
	    if(_ice_delegate == null)
	    {
		return ((_SimpleTie)rhs)._ice_delegate == null;
	    }
	    return _ice_delegate.Equals(((_SimpleTie)rhs)._ice_delegate);
	}

	public override void ProcA(Demo.A obj, Ice.Current __current)
	{
	    _ice_delegate.ProcA(obj, __current);
	}

	private _SimpleOperations _ice_delegate;
    }
}
